<?php
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.3.0-15                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2012-11-23 10:11:36 Andrey Generalov adrenaline.ad@gmail.com Exp $ */
//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php";

function _moduleContent(&$smarty, $module_name)
{
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoSpace_Cleaner.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    //conexion resource
    $pDB = new paloDB($arrConf['dsn_conn_database']);
    //$pDB = "";


    //actions
    $action = getAction();
    $content = "";

    switch($action){
        case "save_new":
            $content = saveNewSpace_Cleaner($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        default: // view_form
            $content = viewFormSpace_Cleaner($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
    }
    return $content;
}

function viewFormSpace_Cleaner($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $pSpace_Cleaner = new paloSantoSpace_Cleaner($pDB);
    $arrFormSpace_Cleaner = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormSpace_Cleaner);

    //begin, Form data persistence to errors and other events.
    $_DATA  = $_POST;

    //$action = getParameter("action");
//    $action = getAction();
    $id     = getParameter("id");
    $smarty->assign("ID", $id); //persistence id with input hidden in tpl
    
/*    if($action=="view")
        $oForm->setViewMode();
    else if($action=="view_edit" || getParameter("save_edit"))
        $oForm->setEditMode();
*/
    //end, Form data persistence to errors and other events.

//    if(($action=="view") || ($action=="view_edit")){ // the action is to view or view_edit.
        $dataSpace_Cleaner = $pSpace_Cleaner->getSpace_CleanerDB();
        if  (is_array($dataSpace_Cleaner) && (count($dataSpace_Cleaner)>0))
            $_DATA = $dataSpace_Cleaner;

        else{
            $smarty->assign("mb_title", _tr("Error get Data"));
            $smarty->assign("mb_message", $pSpace_Cleaner->errMsg);
        }
//    }

    $smarty->assign("SAVE", _tr("Save"));
    $smarty->assign("EDIT", _tr("Edit"));
    $smarty->assign("CANCEL", _tr("Cancel"));
    $smarty->assign("REQUIRED_FIELD", _tr("Required field"));
    $smarty->assign("icon", "images/list.png");

////////////////////////////////////////////////////////////
    $key = array ('monitor_fssize','fax_fssize','backup_fssize','monitor_fs','fax_fs','backup_fs'); 
    $value = array (exec('/usr/local/bin/sc_gettotalspace m'),
		    exec('/usr/local/bin/sc_gettotalspace f'),
		    exec('/usr/local/bin/sc_gettotalspace b'),
		    exec('/usr/local/bin/sc_getfs m'),
		    exec('/usr/local/bin/sc_getfs f'),
		    exec('/usr/local/bin/sc_getfs b')); 
    for ($i = 0; $i<count($key); $i++) { 
	$_DATA[$key[$i]] = $value[$i]; 
    } 
// checking for division by zero
if ($_DATA['monitor_fssize'] != 0 && $_DATA['fax_fssize'] != 0 && $_DATA['backup_fssize'] != 0)
{
    global $baserange;

    $smarty->assign("monitor_range", $_DATA['monitor_max_size']/$_DATA['monitor_fssize']*$baserange);
    $smarty->assign("fax_range", $_DATA['faxes_max_size']/$_DATA['fax_fssize']*$baserange);    
    $smarty->assign("backup_range", $_DATA['backup_max_size']/$_DATA['backup_fssize']*$baserange);
}    
// check for Firefox, IE6-9 for hide input range

$u_agent = $_SERVER['HTTP_USER_AGENT'];
if ((preg_match('/MSIE/i',$u_agent)) or (preg_match('/Firefox/i',$u_agent)))
{
    $smarty->assign("range_hidden","hidden");
} else {
    $smarty->assign("range_hidden","range");
}
// Checking License by sc_cleaner script with parametr 'c'
    $output = array();
    $return_var=1;
    exec('/usr/local/bin/sc_cleaner c 100 1004 1006', $output, $return_var);
    if($return_var == 0) {
	$smarty->assign("lic_uploaded", _tr("License detected. Do not reload the file again please"));
    } elseif ($return_var == 69) {
	$smarty->assign("lic_uploaded", _tr("License wrong or not detected"));
    } else {
	$smarty->assign("lic_uploaded", _tr("Something wrong. Contact with developer. Error: ").$return_var);
    }
/* for future show last start
    $output = array();
    $return_var=1;
    exec('/usr/local/bin/sc_laststart', $output, $return_var);
    if($return_var == 0) {
	$outstrdone = "";
	foreach ($output as $outstr)
	    $outstrdone .= $outstr;
	$smarty->assign("lateststart", $outstrdone);
    }
*/
////////////////////////////////////////////////////////////
    $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl",_tr("Space Cleaner"), $_DATA);    
    $content = "<form method='POST' enctype='multipart/form-data' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";
    return $content;
}

function saveNewSpace_Cleaner($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $pSpace_Cleaner = new paloSantoSpace_Cleaner($pDB);
    $arrFormSpace_Cleaner = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormSpace_Cleaner);

    if(!$oForm->validateForm($_POST)){
        // Validation basic, not empty and VALIDATION_TYPE 
        $smarty->assign("mb_title", _tr("Validation Error"));
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v)
                $strErrorMsg .= "$k, ";
        }
        $smarty->assign("mb_message", $strErrorMsg);
        $content = viewFormSpace_Cleaner($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    }else{
        //NO ERROR, HERE IMPLEMENTATION OF SAVE
        $strMsg ="";
	$strHead=_tr("unsuccesseful");

        // cheking for correct values
	$chkval = array( 
//	    [5~"mms"		=> preg_replace("/^\d+$/", "", intval($_POST['monitor_max_size'])),
	    "mms"		=> intval($_POST['monitor_max_size']),
	    "fms"		=> intval($_POST['faxes_max_size']),	
	    "bms"		=> intval($_POST['backup_max_size']),
	    "monitor_fssize" 	=> intval(exec('/usr/local/bin/sc_gettotalspace m')),
	    "fax_fssize"	=> intval(exec('/usr/local/bin/sc_gettotalspace f')),
	    "backup_fssize"	=> intval(exec('/usr/local/bin/sc_gettotalspace b')));
	    
	$monitor_fs		= exec('/usr/local/bin/sc_getfs m');
	$fax_fs			= exec('/usr/local/bin/sc_getfs f');
	$backup_fs		= exec('/usr/local/bin/sc_getfs b');
	
	$error_incheck = false;
	
	if ($monitor_fs == $fax_fs) {
	    if ($monitor_fs == $backup_fs) { // m = f = b
		if (($chkval["mms"] + $chkval["fms"] + $chkval["bms"])>($chkval["monitor_fssize"])) {$error_incheck = true; };
	    } else { // m = f, m != b
		if (($chkval["mms"] + $chkval["fms"])>($chkval["monitor_fssize"])) {$error_incheck = true; };
		if ($chkval["bms"] > $chkval["backup_fssize"]) {$error_incheck = true; };
		echo "m = f, m!=b";
	    };		
	} else { //m != f
	    echo "m != f";
	    if ($monitor_fs == $backup_fs) { // m != f, m = b
		if (($chkval["mms"] + $chkval["bms"])>($chkval["monitor_fssize"])) {$error_incheck = true; };
		if (($chkval["fms"])>($chkval["fax_fssize"])) {$error_incheck = true; };					
	    } else { // m != f, m!= b
		if ($fax_fs == $backup_fs) { // m != f, m != b, f = b
		    if (($chkval["fms"] + $chkval["bms"])>($chkval["fax_fssize"])) {$error_incheck = true; };
		    if (($chkval["mms"])>($chkval["monitor_fssize"])) {$error_incheck = true; };							
		} else { // m !=f != b
		    if (($chkval["mms"])>($chkval["monitor_fssize"])) {$error_incheck = true; };	
		    if (($chkval["fms"])>($chkval["fax_fssize"])) {$error_incheck = true; };		    
		    if (($chkval["bms"])>($chkval["backup_fssize"])) {$error_incheck = true; };			
		};
	    };	
	};
	
    if ($error_incheck) {
    	$strMsg .= _tr("Error in input parameters. The total value of the input data exceeds that of total space. Values not saved.");
    } else {
	if( $pSpace_Cleaner->setSpace_CleanerDB($_POST)) {
	    $strHead = _tr("Saving state").": "._tr("successful");
	    $strMsg = "<b>"._tr("Input values").": "._tr("saved")."</b><br/>";
    	    if($_POST['enabled']=='on') {
		$mms=$_POST['monitor_max_size'];
		$fms=$_POST['faxes_max_size'];		
		$bms=$_POST['backup_max_size'];		
		switch ($_POST['check_frequency']) {
		    case "val1":
			$paramcron = '"0 * * * *"';
			break;
		    case "val2":
			$paramcron = '"0 */2 * * *"';
			break;
		    case "val3":
			$paramcron = '"0 */3 * * *"';
			break;
		    case "val4":
			$paramcron = '"0 */6 * * *"';
			break;
		    case "val5":
			$paramcron = '"0 */12 * * *"';
			break;
		    case "val6":
			$paramcron = '"0 0 * * *"';
			break;
		    case "val7":
			$paramcron = '"0 0 * * 7"';
			break;
		    case "val8":
			$paramcron = '"0 0 1 * *"';
			break;
		    case "val9":
			$paramcron = '"0 0 1 */3 *"';
			break;
		    case "val10":
			$paramcron = '"0 0 1 1 *"';
			break;
		    default:
			$paramcron = '"0 0 * * *"';
		}
    		$output = array();
    		$return_var=1;
    		exec('/usr/local/bin/sc_crontask_installer r', $output, $return_var);
#		$paramcron .= "/bin/bash /usr/local/bin/sc_daemon start mfb $mms $fms $bms".'"';
#		$paramcron .= '"';
#		$strMsg .= '/usr/local/bin/sc_crontask_installer i '.$paramcron."<br/>";
    		exec('/usr/local/bin/sc_crontask_installer i '.$paramcron.' '.$mms.' '.$fms.' '.$bms, $output, $return_var);

    		if($return_var == 0) {
    		    $strMsg .= "<b>"._tr("Cron task").": "._tr("installed")."</b><br/>";
    		    $pSpace_Cleaner->setEnabled("on");
		}else{
		    $strHead = _tr("Saving state").": "._tr("unsuccessful");
		    $strMsg .= "<b>"._tr("Cron task installing").": "._tr("Error")." ".$return_var."</b><br/>";
		}
	    } else {
		$output = array();
    		$return_var=1;
    		exec('/usr/local/bin/sc_crontask_installer r', $output, $return_var);
    		if($return_var == 0) {
    		    $strMsg .= "<b>"._tr("Cron task").": "._tr("uninstalled")."</b><br/>";
    		    $pSpace_Cleaner->setEnabled("off");
		}else{
		    $strHead = _tr("Saving state").": "._tr("unsuccessful");
		    $strMsg .= "<b>"._tr("Cron task uninstalling").": "._tr("Error")." ".$return_var."</b><br/>";
		    $pSpace_Cleaner->setEnabled("on");
		}
	    }		
	}else{
	    $strHead = _tr("Saving state").": "._tr("unsuccessful");
	    $strMsg .= "<b>"._tr("Input values").": "._tr("not saved")."</b><br/>";	    
        }             
    }
    	$smarty->assign("mb_title", $strHead);
    	$smarty->assign("mb_message", $strMsg);
    	$content = viewFormSpace_Cleaner($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
}
    
    if(is_uploaded_file($_FILES['file_lic']['tmp_name'])) {
        $licfiledir = "/etc/elastix/addons/space_cleaner/user.lic";
        copy($_FILES['file_lic']['tmp_name'], $licfiledir);
        $strMsg .= "<b>"._tr("License file installed.")."</b><br/>";
        $smarty->assign("mb_message", $strMsg);
        $content = viewFormSpace_Cleaner($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    }
    
    return $content;
}

function createFieldForm()
{
    $arrOptions = array(	'val1' => _tr('Every one hour'),
				'val2' => _tr('Every two hours'),
				'val3' => _tr('Every three hours'),
				'val4' => _tr('Every six hours'),
				'val5' => _tr('Every 12 hours'),
				'val6' => _tr('Every one day'),
				'val7' => _tr('Every week'),
				'val8' => _tr('Every month'),
				'val9' => _tr('Every three months'),
				'val10' => _tr('Every year'),
			);

    $arrFields = array(
            "enabled"   => array(      "LABEL"                  => _tr("Enabled"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "CHECKBOX",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "check_frequency"   => array(      "LABEL"                  => _tr("Check frequency"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "SELECT",
                                            "INPUT_EXTRA_PARAM"      => $arrOptions,
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "si",
                                            ),
            "monitor_max_size"   => array(      "LABEL"                  => _tr("Size of folder for storing audio recordings"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'mms', 'onchange' => "check_limit(this)"),
//                                            "INPUT_EXTRA_PARAM"      => array('id' => 'mms', 'pattern' =>'^[0-9]+$'),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "faxes_max_size"   => array(      "LABEL"                  => _tr("Size of folder for storing faxes"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'fms', 'onchange' => "check_limit(this)"),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "backup_max_size"   => array(      "LABEL"                  => _tr("Size of folder for storing elastix backups"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'bms', 'onchange' => "check_limit(this)"),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "sizescale"		=> array(      "LABEL"                  => _tr("MB"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "fromtotal"		=> array(      "LABEL"                  => _tr("total size"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "monitor_fs"		=> array(      "LABEL"       => _tr("On filesystem:"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'mfs', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "fax_fs"		=> array(      "LABEL"       =>  _tr("On filesystem:"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'ffs', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "backup_fs"		=> array(      "LABEL"       => _tr("On filesystem:"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'bfs', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "monitor_fssize"		=> array(      "LABEL"       => "",
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'mfss', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "fax_fssize"		=> array(      "LABEL"       => "",
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'ffss', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "numeric",
                                            "EDITABLE"               => "no",
                                            ),
            "backup_fssize"		=> array(      "LABEL"       => "",
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'bfss', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),


            "monitor_usize"		=> array(      "LABEL"       => _tr("unallocated space"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'mus', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "fax_usize"			=> array(      "LABEL"       => _tr("unallocated space"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'fus', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "numeric",
                                            "EDITABLE"               => "no",
                                            ),
            "backup_usize"		=> array(      "LABEL"       => _tr("unallocated space"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => array('id' => 'bus', 'readonly' => 'yes', 'disabled'=>'yes','size'=>'10'),
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),
            "lic_upload"		=> array(      "LABEL"       => _tr("Choose license file for upload"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => "",
                                            "EDITABLE"               => "no",
                                            ),

            );
    return $arrFields;
}


function getAction()
{
    if(getParameter("save_new")) //Get parameter by POST (submit)
        return "save_new";
    else if(getParameter("save_edit"))
        return "save_edit";
    else if(getParameter("delete")) 
        return "delete";
    else if(getParameter("new_open")) 
        return "view_form";
    else if(getParameter("action")=="view")      //Get parameter by GET (command pattern, links)
        return "view_form";
    else if(getParameter("action")=="view_edit")
        return "view_form";
    else
        return "report"; //cancel
//	return "view_edit";
}

?>