<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.3.0-15                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: paloSantoSpace_Cleaner.class.php,v 1.1 2012-11-23 10:11:36 Andrey Generalov adrenaline.ad@gmail.com Exp $ */
class paloSantoSpace_Cleaner{
    var $_DB;
    var $errMsg;

    function paloSantoSpace_Cleaner(&$pDB)
    {
        // Se recibe como parámetro una referencia a una conexión paloDB
        if (is_object($pDB)) {
            $this->_DB =& $pDB;
            $this->errMsg = $this->_DB->errMsg;
        } else {
            $dsn = (string)$pDB;
            $this->_DB = new paloDB($dsn);

            if (!$this->_DB->connStatus) {
                $this->errMsg = $this->_DB->errMsg;
                // debo llenar alguna variable de error
            } else {
                // debo llenar alguna variable de error

            }                
        }
// init db will be release in rpm
//                $this->createTable();
    }

    /*HERE YOUR FUNCTIONS*/
////////////////////////
    function setEnabled($str)
    {
        $query = "UPDATE sc SET value=? WHERE name='enabled'";
        $str_arr = array($str);
        if($this->_DB->genQuery($query,$str_arr))
        {
            $this->errMsg = $this->_DB->errMsg;
            return false;
        }
        return true;
    }
    function getSpace_CleanerDB()
    {
        $query   = "SELECT name, value FROM sc";
        $key=$this->_DB->fetchTable($query);
        if($key==FALSE){
            $this->errMsg = $this->_DB->errMsg;
	    return array();
        }
	$result = array();        
	for ($i = 0; $i<count($key); $i++) 
	{ 
            $result[$key[$i][0]]=$key[$i][1];
        }              
        return $result;        
    }
    function setSpace_CleanerDB($DATA)
    {
	$result=false;
	$query = "DELETE FROM sc WHERE name <> 'enabled'";
	$result=$this->_DB->genExec($query);
        if($result==false){
            $this->errMsg = $this->_DB->errMsg;
            return false;
        }else{
    	    $result=false;
	    $arrname=array(
			'monitor_max_size',
			'faxes_max_size',
			'backup_max_size',
			'check_frequency',
//			'enabled'
			);
	    $arrval=array(
			$DATA['monitor_max_size'],
			$DATA['faxes_max_size'],
			$DATA['backup_max_size'],
			$DATA['check_frequency'],
//			$DATA['enabled']
			);			
	    return $this->setval($arrname,$arrval);
        }	    	
    return $result;        
    }

    function setval($arrname,$arrval)
    {
	$result=false;
	for ($i = 0; $i<count($arrname); $i++) { 
    	    $query = "INSERT INTO sc (name,value) VALUES ('".$arrname[$i]."', '".$arrval[$i]."')";
    	    $result=$this->_DB->genExec($query);
	}
	return $result;
    }

    function createTable()
    {

	$query = "CREATE TABLE r (
	id integer 	primary key,
	name		TEXT,
	value		TEXT	
	)";
	if($this->_DB->genExec($query))
	{
	    $query = "INSERT INTO r (name,value)
	    Values('st','".time()."'
	    )";
	    $this->_DB->genExec($query);
	}	
	$query = "CREATE TABLE sc (
	id integer 	primary key,
	name		TEXT,
	value		TEXT	
	)";
	
        if ($this->_DB->genExec($query))
	{
	    $arrname=array(
			'monitor_max_size',
			'faxes_max_size',
			'backup_max_size',
			'check_frequency',
			'enabled',
			);
	    $arrval=array(
			'0',
			'0',
			'0',
			'val6',
			'off'
			);
			
	    return $this->setval($arrname,$arrval);
	}else{
	    return false;
	}	
    }

    function getNumSpace_Cleaner($filter_field, $filter_value)
    {
        $where    = "";
        $arrParam = null;
        if(isset($filter_field) & $filter_field !=""){
            $where    = "where $filter_field like ?";
            $arrParam = array("$filter_value%");
        }

        $query   = "SELECT COUNT(*) FROM table $where";

        $result=$this->_DB->getFirstRowQuery($query, false, $arrParam);

        if($result==FALSE){
            $this->errMsg = $this->_DB->errMsg;
            return 0;
        }
        return $result[0];
    }

    function getSpace_Cleaner($limit, $offset, $filter_field, $filter_value)
    {
        $where    = "";
        $arrParam = null;
        if(isset($filter_field) & $filter_field !=""){
            $where    = "where $filter_field like ?";
            $arrParam = array("$filter_value%");
        }

        $query   = "SELECT * FROM sc $where LIMIT $limit OFFSET $offset";

        $result=$this->_DB->fetchTable($query, true, $arrParam);

        if($result==FALSE){
            $this->errMsg = $this->_DB->errMsg;
            return array();
        }
        return $result;
    }

    function getSpace_CleanerById($id)
    {
        $query = "SELECT * FROM sc WHERE id=?";

        $result=$this->_DB->getFirstRowQuery($query, true, array("$id"));

        if($result==FALSE){
            $this->errMsg = $this->_DB->errMsg;
            return null;
        }
        return $result;
    }
}
?>